#include "bitmap.h"
#include <vector>
using namespace std;

void Bitmap::_free() {
    if(bmp != NULL) {
        if(--*refcnt <= 0) {
            destroy_bitmap(bmp);
            delete refcnt;
        }
    }
    refcnt = NULL;
    bmp = NULL;
}

void Bitmap::_copy(const Bitmap& other) {
    _free();
    refcnt = other.refcnt;
    bmp = other.bmp;
    if(refcnt) ++*refcnt;
}

bool Bitmap::load(string filename) {
	_free();
    bmp = load_bitmap(filename.c_str(), NULL);
    refcnt = new int(1);
	return (bmp != NULL);
}

bool Bitmap::make(int w, int h) {
    _free();
    bmp = create_bitmap(w, h);
    if (bmp != NULL) refcnt = new int(1);
    return (bmp != NULL);
}

Bitmap Bitmap::sub(int x, int y, int w, int h) {
    Bitmap r = Bitmap(create_sub_bitmap(bmp, x, y, w, h), true);
    r.isSubBitmap = true;
    return r;
}
